# ABA Generator

An open source Ruby gem for creating ABA (sometimes called "Cemtext" or "Direct Entry") files used for defining batch payments and supported by all major Australian banks.

This gem was created by [Keegan Bakker](https://github.com/kbakker) and maintained by [Audata](https://github.com/audata).

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'aba_generator'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install aba_generator

## Usage

```ruby
aba = AbaGenerator.new(
    instutition_code: "CBA",
    description: "PAYROLL",
    source_bsb: "123-456",
    source_account_number: "123456789",
    remitter_name: "TEST",
    include_balancing_line: true # defaults to false
)

@payments.each do |payment|
    aba.add_row(
        bsb: '123-456',
        account_number: '1234567',
        account_name: 'J E SMITH',
        amount: 100.00,
        reference: "Payroll #{Time.new.strftime('%m-%d')}"
    )
end

output = aba.generate
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/aba_generator. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/[USERNAME]/aba_generator/blob/master/CODE_OF_CONDUCT.md).

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the AbaGenerator project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/aba_generator/blob/master/CODE_OF_CONDUCT.md).
